#ifndef __UWater_DEBUG_PRINT_H
#define __UWater_DEBUG_PRINT_H


#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "type.h"

#define PRINT_BUF_SIZE    1024

typedef struct {
    u16 saved_data_len;    //ݵĳ
    u16 printf_data_len;   //Ѵӡݳ
    u16 print_one_time_len;//δӡ
    u8  send_msg;
    u8  buf_overflow;       //
} PRINT_STRUCT;

typedef enum {
    PRINT_DATA_S0 = 0,
    PRINT_DATA_S1,
    PRINT_DATA_S2,
    PRINT_DATA_S3,
    PRINT_DATA_S4,
    PRINT_DATA_S5,
    PRINT_DATA_DEFAULT
} PRINT_DATA;

//NBݴӡ
void OpenPrintNbDataSwitch(void);
//رNBݴӡ
void ClosePrintNbDataSwitch(void);
u8 GetPrintNbDataSwitch(void);
//ݴӡ
void OpenPrintProgramDataSwitch(void);
//رճݴӡ
void ClosePrintProgramDataSwitch(void);
/***********************ӡ********************************
Function:    void PrintNbData (u8 *data_src, u16 len)
Description: ӡ
Input:     data_src Դָ len ݳ
 ****************************************************************/
void PrintNbData(u8 *data_src, u16 len);
/***********************ӡ********************************
Function:    void PrintProgramData (u8 *data_src, u16 len)
Description: ӡ
Input:     data_src Դָ len ݳ
 ****************************************************************/
void PrintProgramData(u8 *data_src, u16 len);
//ӡ״̬Ƿ
u8 PrintDataMachineIfIdle(void);
/*******************************ӡ״̬******************************
Function:      void PrintDataMachine(void)
Description:   ӡ״̬
 ***************************************************************************/
void PrintDataMachine(void);

#endif


